#!/bin/bash

function log
{
  echo $(date)" "$1
}

bbox_control="/var/tmp/bbox_control"
bbox_control2="/var/tmp/bbox_control2"
bbox_token="/var/tmp/bbox_token"
bbox_cookies="/var/tmp/bbox_cookies"
ping_count=1
bbox_ip=bbox.lan
last_reboot=$(date +%s)

log "-- Bbox Sensation Monitoring --"
log "par @fenarinarsa (7/2/2013)"
log "Utilisez à vos risques et périls. Testé sur Bbox Sagemcom F@st3965b"

which_curl=$(which curl)

if [[ -z $which_curl ]]
then
  log "Erreur : 'curl' n'est pas installé sur ce système."
  log "Merci de l'installer avant d'exécuter ce script."
  exit 1
fi

if [[ $# == 0 ]]
then
  which_host=$(which host)
  if [[ -z $which_host ]]
  then
    log "Erreur : 'host' n'est pas installé sur ce système."
    log "Merci d'installer le package 'dnsutils' ou bien de spécifier l'IP de votre Bbox en paramètre."
    exit 1
  fi
  bbox_ip=$(host bbox.lan | sed 's/.*has address \([0-9a-fA-F\.:]*\)/\1/')
else
  bbox_ip=$1
fi


log "IP trouvée pour la Bbox : $bbox_ip"
log "Démarrage du monitoring"

while true
do
  count=$(ping -c $ping_count $bbox_ip | grep 'received' | awk -F',' '{ print $2 }' | awk '{ print $1 }')

  if [[ count -eq 0 ]]
  then

    log "Le modem Bbox ne répond plus et commence à bugger."
    new_reboot=$(date +%s)
    let uptime=$new_reboot-$last_reboot
    #uptime=$(echo $uptime | bc)
    log "uptime = $uptime secondes"
    log "Tentative de reboot de la Bbox..."

    curl "$bbox_ip/novice/gtw.htm" -# -c $bbox_cookies --connect-timeout 200 -m 300 > $bbox_control2 2> /dev/null
    if [[ $? != 0 ]]
    then
      log "Erreur : Impossible d'accéder à l'interface de web de la Bbox. Monitoring arrêté."
      exit 1
    fi

    cat $bbox_control2 | tr "\t\n" " " | tr -d ' ' > $bbox_control
    sed "s/.*functionreboot(){vartoken=eval('(\"\([a-zA-Z0-9]*\)\")').*/\1/" $bbox_control > $bbox_token
    token=$(cat $bbox_token)
    reply=$(curl -b $bbox_cookies -# --connect-timeout 200 -m 300 -d "token=$token&fct=reboot" "$bbox_ip/cgi-bin/generic.cgi")
    replycode=$(echo $reply | sed 's/.*{"\([a-ZA-Z0-9]*\)".*/\1/')

    rm $bbox_cookies 2> /dev/null
    rm $bbox_control 2> /dev/null
    rm $bbox_token 2> /dev/null
    rm $bbox_control2 2> /dev/null

    if [[ $replycode == "reboot" ]]
    then
      last_reboot=$new_reboot
      log "La Bbox redémarre ! Reprise du monitoring dans 15mn."
      sleep 900
      log "Le monitoring recommence maintenant."
    else
      log "Erreur : $reply"
      log "Un redémarrage électrique est peut-être nécessaire."
      sleep 15
    fi

  else

    sleep 15

  fi

done



